////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// TSpinEditEx, TDateTimeSpin \[Xt@C Ver.2.0                          //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////
{
  TRapidBtn/TRapidBtnLite̓Ȋ֐EvpeB
    TimerStart    : AłJn
    TimerStop     : AłI
    FontBold      : }EXJ[\{^ɂƂtHg𑾎ɕς
}
{
  TSpinButtonEx̓ȃvpeB
    Acceleration  : {^ŉ邩ۂ
    Orientation   : {^̕i㉺EEj
    OnDownClick   : {^i܂͉E{^j̃NbÑCxg
    OnUpClick     : {^i܂͍{^j̃NbÑCxg
}
{
  TSpinEditEx̓ȃvpeB
    Acceleration    : {^ŉ邩ۂ
    Increment       : {^̃NbNE}EX̃XN[őlij
    OnMouseWheel    : }EXzC[쎞̃Cxg
    OnMouseWheelDown: }EXzC[]쎞̃Cxg
    OnMouseWheelUp  : }EXzC[]쎞̃Cxg
}
{
  TDateTimeSpin̓ȃvpeB
    Acceleration    : {^ŉ邩ۂ
    OnMouseWheel    : }EXzC[쎞̃Cxg
    OnMouseWheelDown: }EXzC[]쎞̃Cxg
    OnMouseWheelUp  : }EXzC[]쎞̃Cxg
}
unit SpinEditEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, CommCtrl, StdCtrls, ComCtrls,
  ExtCtrls, Graphics, NumericEdit;

const
  DEF_ACCEL_DELTA = 100;
  DEF_MAX_INTERVAL = 500;
  DEF_MIN_INTERVAL = 10;

type
  //^C}[
  TAccelTimer = class(TTimer)
  private
    { Private 錾 }
    FAccelDelta: Cardinal;
    FMaxInterval: Cardinal;
    FMinInterval: Cardinal;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    procedure RepeatStart(FullSpeed: Boolean);
    procedure RepeatStop;
    procedure StepDelta;
    property AccelDelta: Cardinal read FAccelDelta write FAccelDelta default DEF_ACCEL_DELTA;
    property MaxInterval: Cardinal read FMaxInterval write FMaxInterval default DEF_MAX_INTERVAL;
    property MinInterval: Cardinal read FMinInterval write FMinInterval default DEF_MIN_INTERVAL;
    property Enabled stored False;
    property Interval stored False;
  end;

  //AŃ{^Lite
  TRapidBtnLite = class(TWinControl)
  private
    { Private 錾 }
    FFontBold: Boolean;
    FAccelTimer: TAccelTimer;
    procedure SetButtonEnter(AEnter: Boolean);
    procedure SetButtonStyle(ADefault: Boolean);
    procedure SetFontBold(const Value: Boolean);
    procedure TimerExpired(Sender: TObject);
    procedure CMFocusChanged(var Message: TCMFocusChanged); message CM_FOCUSCHANGED;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure CNCommand(var Message: TWMCommand); message CN_COMMAND;
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function UseRightToLeftAlignment: Boolean; override;
    procedure TimerStart(ACtrl: Boolean = False);
    procedure TimerStop;
  published
    { Published 錾 }
    property Anchors;
    property BiDiMode;
    property Caption;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property FontBold: Boolean read FFontBold write SetFontBold default True;
    property Font;
    property ParentBiDiMode;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  //AŃ{^
  TRapidButton = class(TButton)
  private
    { Private 錾 }
    FFontBold: Boolean;
    FAccelTimer: TAccelTimer;
    procedure SetFontBold(const Value: Boolean);
    procedure SetButtonEnter(AEnter: Boolean);
    procedure TimerExpired(Sender: TObject);
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
  protected
    { Protected 錾 }
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure TimerStart(ACtrl: Boolean = False);
    procedure TimerStop;
  published
    { Published 錾 }
    property FontBold: Boolean read FFontBold write SetFontBold default True;
  end;

  TSpinUpDown = class(TWinControl)
  private
    { Private 錾 }
    FLastUpClick: Boolean;
    FAcceleration: Boolean;
    FAccelTimer: TAccelTimer;
    FOnDownClick: TNotifyEvent;
    FOnUpClick: TNotifyEvent;
    procedure UpDownClick(Direction: Smallint);
    procedure TimerExpired(Sender: TObject);
    procedure WMHScroll(var Message: TWMHScroll); message CN_HSCROLL;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMVScroll(var Message: TWMVScroll); message CN_VSCROLL;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    function GetParams: DWORD; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure TimerStart(ACtrl: Boolean = False);
    procedure TimerStop;
    property Acceleration: Boolean read FAcceleration write FAcceleration default True;
    property OnDownClick: TNotifyEvent read FOnDownClick write FOnDownClick;
    property OnUpClick: TNotifyEvent read FOnUpClick write FOnUpClick;
  end;

  TSpinButtonEx = class(TSpinUpDown)
  private
    { Private 錾 }
    FOrientation: TUDOrientation;
    procedure SetOrientation(Value: TUDOrientation);
  protected
    { Protected 錾 }
    function GetParams: DWORD; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property Acceleration;
    property Align;
    property Anchors;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Orientation: TUDOrientation read FOrientation write SetOrientation default udVertical;
    property ParentCtl3D;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnDownClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDock;
    property OnStartDrag;
    property OnUpClick;
  end;

  TSpinEditEx = class(TIntegerEdit)
  private
    { Private 錾 }
    FIncrement: LongInt;
    FUpDownBtn: TSpinUpDown;
    function GetAcceleration: Boolean;
    procedure SetAcceleration(Value: Boolean);
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure SetEditRect;
    procedure SetEnabled(Value: Boolean); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure DoUpClick(Sender: TObject);
    procedure DoDownClick(Sender: TObject);
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property Acceleration: Boolean read GetAcceleration write SetAcceleration default True;
    property Increment: LongInt read FIncrement write FIncrement default 1;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
  end;

  TDateTimeSpin = class(TDateTimeEdit)
  private
    { Private 錾 }
    FUpDownBtn: TSpinUpDown;
    function GetAcceleration: Boolean;
    procedure SetAcceleration(Value: Boolean);
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure SetEditRect;
    procedure SetBtnRect;
    procedure CalcBtnHeight(var BtnTop, BtnHeight: Integer); dynamic;
    procedure SetEnabled(Value: Boolean); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    function DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    function DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean; override;
    procedure DoUpClick(Sender: TObject); dynamic;
    procedure DoDownClick(Sender: TObject); dynamic;
    procedure DoIncrement(Direction: Smallint);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property Acceleration: Boolean read GetAcceleration write SetAcceleration default True;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
  end;


implementation

uses Forms, DateUtilsEx;


////////////////////////////////////////////////////////////////////////////////
// TAccelTimer                                                                //
////////////////////////////////////////////////////////////////////////////////

constructor TAccelTimer.Create(AOwner: TComponent);
begin
  inherited;
  Enabled := False;
  FAccelDelta := DEF_ACCEL_DELTA;
  FMaxInterval := DEF_MAX_INTERVAL;
  FMinInterval := DEF_MIN_INTERVAL;
end;

procedure TAccelTimer.RepeatStart(FullSpeed: Boolean);
begin
  if FullSpeed then
    Interval := MinInterval
  else
    Interval := MaxInterval;
  Enabled := True;
end;

procedure TAccelTimer.RepeatStop;
begin
  Enabled := False;
end;

procedure TAccelTimer.StepDelta;
begin
  if Interval > MinInterval then
  begin
    if Interval > MinInterval + FAccelDelta then
      Interval := Interval - FAccelDelta
    else
      Interval := MinInterval;
  end;
end;


////////////////////////////////////////////////////////////////////////////////
// TRapidBtnLite                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TRapidBtnLite.Create(AOwner: TComponent);
begin
  inherited;
  if SysLocale.FarEast and (Win32Platform = VER_PLATFORM_WIN32_NT) then ImeMode := imDisable;
  ControlStyle := [csSetCaption, csOpaque, csDoubleClicks];
  Width := 75;
  Height := 25;
  FFontBold := True;
end;

destructor TRapidBtnLite.Destroy;
begin
  if Assigned(FAccelTimer) then FreeAndNil(FAccelTimer);
  inherited;
end;

procedure TRapidBtnLite.CreateParams(var Params: TCreateParams);
begin
  inherited;
  CreateSubClass(Params, 'BUTTON');
  Params.Style := Params.Style or BS_PUSHBUTTON;
end;

procedure TRapidBtnLite.CMFocusChanged(var Message: TCMFocusChanged);
begin
  with Message do
    if Sender is TRapidBtnLite then
      SetButtonStyle(Sender = Self)
    else
      SetButtonStyle(False);
  inherited;
end;

procedure TRapidBtnLite.CMMouseEnter(var Message: TMessage);
begin
  SetButtonEnter(True);
  inherited;
end;

procedure TRapidBtnLite.CMMouseLeave(var Message: TMessage);
begin
  SetButtonEnter(False);
  inherited;
end;

procedure TRapidBtnLite.CNCommand(var Message: TWMCommand);
begin
  if Message.NotifyCode = BN_CLICKED then Click;
end;

procedure TRapidBtnLite.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  DefaultHandler(Message);
end;

function TRapidBtnLite.UseRightToLeftAlignment: Boolean;
begin
  Result := False;
end;

procedure TRapidBtnLite.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button = mbLeft then TimerStart(ssCtrl in Shift);
end;

procedure TRapidBtnLite.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  TimerStop;
end;

procedure TRapidBtnLite.SetFontBold(const Value: Boolean);
begin
  if FFontBold = Value then Exit;
  FFontBold := Value;
  if FFontBold then
  begin
    ParentFont := False;
    Font.Style := Font.Style - [fsBold];
  end;
  Invalidate;
end;

procedure TRapidBtnLite.SetButtonEnter(AEnter: Boolean);
begin
  if not HandleAllocated then Exit;

  if FFontBold then
  begin
    if AEnter then
      Font.Style := Font.Style + [fsBold]
    else
      Font.Style := Font.Style - [fsBold];
  end;
end;

procedure TRapidBtnLite.SetButtonStyle(ADefault: Boolean);
const
  BS_MASK = $000F;
var
  BtnStyle: Word;
begin
  if not HandleAllocated then Exit;

  if ADefault then
    BtnStyle := BS_DEFPUSHBUTTON
  else
    BtnStyle := BS_PUSHBUTTON;
  if (GetWindowLong(Handle, GWL_STYLE) and BS_MASK) <> BtnStyle then
    SendMessage(Handle, BM_SETSTYLE, BtnStyle, 1);
end;

procedure TRapidBtnLite.TimerStart(ACtrl: Boolean);
begin
  if not Assigned(FAccelTimer) then
  begin
    FAccelTimer := TAccelTimer.Create(Self);
    FAccelTimer.OnTimer := TimerExpired;
  end;
  FAccelTimer.RepeatStart(ACtrl);
end;

procedure TRapidBtnLite.TimerStop;
begin
  if Assigned(FAccelTimer) then FAccelTimer.RepeatStop;
end;

procedure TRapidBtnLite.TimerExpired(Sender: TObject);
begin
  if MouseCapture then
  begin
    try
      FAccelTimer.StepDelta;
      Click;
    except
      FAccelTimer.RepeatStop;
    end;
  end
  else
    FAccelTimer.RepeatStop;
end;


////////////////////////////////////////////////////////////////////////////////
// TRapidButton                                                               //
////////////////////////////////////////////////////////////////////////////////

constructor TRapidButton.Create(AOwner: TComponent);
begin
  inherited;
  FFontBold := True;
end;

destructor TRapidButton.Destroy;
begin
  if Assigned(FAccelTimer) then FreeAndNil(FAccelTimer);
  inherited;
end;

procedure TRapidButton.CMMouseEnter(var Message: TMessage);
begin
  SetButtonEnter(True);
  inherited;
end;

procedure TRapidButton.CMMouseLeave(var Message: TMessage);
begin
  SetButtonEnter(False);
  inherited;
end;

procedure TRapidButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button = mbLeft then TimerStart(ssCtrl in Shift);
end;

procedure TRapidButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  TimerStop;
end;

procedure TRapidButton.SetFontBold(const Value: Boolean);
begin
  if FFontBold = Value then Exit;
  FFontBold := Value;
  if FFontBold then
  begin
    ParentFont := False;
    Font.Style := Font.Style - [fsBold];
  end;
  Invalidate;
end;

procedure TRapidButton.SetButtonEnter(AEnter: Boolean);
begin
  if not HandleAllocated then Exit;

  if FFontBold then
  begin
    if AEnter then
      Font.Style := Font.Style + [fsBold]
    else
      Font.Style := Font.Style - [fsBold];
  end;
end;

procedure TRapidButton.TimerStart(ACtrl: Boolean);
begin
  if not Assigned(FAccelTimer) then
  begin
    FAccelTimer := TAccelTimer.Create(Self);
    FAccelTimer.OnTimer := TimerExpired;
  end;
  FAccelTimer.RepeatStart(ACtrl);
end;

procedure TRapidButton.TimerStop;
begin
  if Assigned(FAccelTimer) then FAccelTimer.RepeatStop;
end;

procedure TRapidButton.TimerExpired(Sender: TObject);
begin
  if MouseCapture then
  begin
    try
      FAccelTimer.StepDelta;
      Click;
    except
      FAccelTimer.RepeatStop;
    end;
  end
  else
    FAccelTimer.RepeatStop;
end;


////////////////////////////////////////////////////////////////////////////////
// TSpinUpDown                                                                //
////////////////////////////////////////////////////////////////////////////////

constructor TSpinUpDown.Create(AOwner: TComponent);
begin
  inherited;
  Width := GetSystemMetrics(SM_CXVSCROLL);
  Height := GetSystemMetrics(SM_CYVSCROLL);
  FAcceleration := True;
  FLastUpClick := False;
  ControlStyle := ControlStyle - [csDoubleClicks];
end;

destructor TSpinUpDown.Destroy;
begin
  if Assigned(FAccelTimer) then FreeAndNil(FAccelTimer);
  inherited;
end;

function TSpinUpDown.GetParams: DWORD;
begin
  Result := UDS_SETBUDDYINT or UDS_ALIGNRIGHT or UDS_ARROWKEYS or UDS_NOTHOUSANDS;
end;

procedure TSpinUpDown.CreateParams(var Params: TCreateParams);
begin
  InitCommonControl(ICC_UPDOWN_CLASS);
  inherited CreateParams(Params);
  Params.Style := Params.Style or GetParams;
  CreateSubClass(Params, UPDOWN_CLASS);
  with Params.WindowClass do
    style := style and not (CS_HREDRAW or CS_VREDRAW) or CS_DBLCLKS;
end;

procedure TSpinUpDown.CreateWnd;
var
  AccelArray: array [0..0] of TUDAccel;
  Origin: Integer;
begin
  Origin := Width;
  inherited CreateWnd;
  Width := Origin;
  SendMessage(Handle, UDM_SETRANGE, 0, MakeLong(2, 0));
  SendMessage(Handle, UDM_SETPOS, 0, MakeLong(1, 0));
  SendMessage(Handle, UDM_GETACCEL, 1, Longint(@AccelArray));
  AccelArray[0].nInc := 1;
  SendMessage(Handle, UDM_SETACCEL, 1, Longint(@AccelArray));
end;

procedure TSpinUpDown.WMVScroll(var Message: TWMVScroll);
begin
  inherited;
  if Message.ScrollCode = SB_THUMBPOSITION then
  begin
    UpDownClick(Message.Pos);
    Message.Pos := 1;
  end;
end;

procedure TSpinUpDown.WMSize(var Message: TWMSize);
var
  R: TRect;
begin
  inherited;
  R := ClientRect;
  InvalidateRect(Handle, @R, False);
end;

procedure TSpinUpDown.WMHScroll(var Message: TWMHScroll);
begin
  inherited;
  if Message.ScrollCode = SB_THUMBPOSITION then
  begin
    UpDownClick(Message.Pos);
    Message.Pos := 1;
  end;
end;

procedure TSpinUpDown.UpDownClick(Direction: Smallint);
begin
  case Direction of
    0: FLastUpClick := False;
    1: FLastUpClick := not FLastUpClick;
    2: FLastUpClick := True;
  end;

  if FLastUpClick then
  begin
    if Assigned(FOnUpClick) then FOnUpClick(Self);
  end
  else
  begin
    if Assigned(FOnDownClick) then FOnDownClick(Self);
  end;
end;

procedure TSpinUpDown.TimerExpired(Sender: TObject);
begin
  if MouseCapture and FAcceleration then
  begin
    try
      FAccelTimer.StepDelta;
      UpDownClick(-1);
    except
      FAccelTimer.RepeatStop;
    end;
  end
  else
    FAccelTimer.RepeatStop;
end;

procedure TSpinUpDown.TimerStart(ACtrl: Boolean);
begin
  if not FAcceleration then Exit;
  if not Assigned(FAccelTimer) then
  begin
    FAccelTimer := TAccelTimer.Create(Self);
    FAccelTimer.OnTimer := TimerExpired;
  end;
  FAccelTimer.RepeatStart(ACtrl);
end;

procedure TSpinUpDown.TimerStop;
begin
  if Assigned(FAccelTimer) then FAccelTimer.RepeatStop;
end;

procedure TSpinUpDown.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  if Button = mbLeft then TimerStart(ssCtrl in Shift);
end;

procedure TSpinUpDown.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  inherited;
  TimerStop;
end;


////////////////////////////////////////////////////////////////////////////////
// TSpinButtonEx                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TSpinButtonEx.Create(AOwner: TComponent);
begin
  inherited;
  Height := Height * 3 div 2;
  FOrientation := udVertical;
end;

function TSpinButtonEx.GetParams: DWORD;
begin
  Result := inherited GetParams;
  if FOrientation = udHorizontal then Result := Result or UDS_HORZ;
end;

procedure TSpinButtonEx.SetOrientation(Value: TUDOrientation);
begin
  if FOrientation = Value then Exit;
  FOrientation := Value;
  if ComponentState * [csLoading, csUpdating] = [] then
    SetBounds(Left, Top, Height, Width);
  if HandleAllocated then
    SendMessage(Handle, UDM_SETBUDDY, 0, 0);
  RecreateWnd;
end;


////////////////////////////////////////////////////////////////////////////////
// TSpinEditEx                                                                //
////////////////////////////////////////////////////////////////////////////////

constructor TSpinEditEx.Create(AOwner: TComponent);
begin
  inherited;
  FUpDownBtn := TSpinUpDown.Create(Self);
  FUpDownBtn.Parent := Self;
  FUpDownBtn.TabStop := False;
  FUpDownBtn.Visible := True;
  FUpDownBtn.OnUpClick := DoUpClick;
  FUpDownBtn.OnDownClick := DoDownClick;
  FIncrement := 1;
end;

destructor TSpinEditEx.Destroy;
begin
  if Assigned(FUpDownBtn) then FreeAndNil(FUpDownBtn);
  inherited Destroy;
end;

procedure TSpinEditEx.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;
end;

procedure TSpinEditEx.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

function TSpinEditEx.GetAcceleration: Boolean;
begin
  if Assigned(FUpDownBtn) then
    Result := FUpDownBtn.Acceleration
  else
    Result := True;
end;

procedure TSpinEditEx.SetAcceleration(Value: Boolean);
begin
  if Assigned(FUpDownBtn) then FUpDownBtn.Acceleration := Value;
end;

procedure TSpinEditEx.SetEnabled(Value: Boolean);
begin
  if Enabled = Value then Exit;
  inherited SetEnabled(Value);
  if Assigned(FUpDownBtn) then FUpDownBtn.Enabled := Value;
end;

procedure TSpinEditEx.SetEditRect;
var
  Loc: TRect;
begin
  Loc.Bottom := ClientHeight;
  if NewStyleControls and Ctl3D then
    Loc.Right := ClientWidth - FUpDownBtn.Width - 2
  else
    Loc.Right := ClientWidth - FUpDownBtn.Width;
  Loc.Top := 1;
  Loc.Left := 0;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;

procedure TSpinEditEx.WMSize(var Message: TWMSize);
begin
  inherited;
  if Assigned(FUpDownBtn) then
  begin
    if NewStyleControls and Ctl3D then
      FUpDownBtn.SetBounds(Width - FUpDownBtn.Width - 3, -1, FUpDownBtn.Width, Height - 2)
    else
      FUpDownBtn.SetBounds(Width - FUpDownBtn.Width - 1, 1, FUpDownBtn.Width, Height - 2);
    SetEditRect;
  end;
end;

procedure TSpinEditEx.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  if Key = VK_UP then
    DoUpClick(Self)
  else if Key = VK_DOWN then
    DoDownClick(Self);
end;

function TSpinEditEx.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);
  if Result or ReadOnly then Exit;
  Value := Value + FIncrement;
end;

function TSpinEditEx.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);
  if Result or ReadOnly then Exit;
  Value := Value - FIncrement;
end;

procedure TSpinEditEx.DoUpClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  Value := Value + FIncrement;
end;

procedure TSpinEditEx.DoDownClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  Value := Value - FIncrement;
end;


////////////////////////////////////////////////////////////////////////////////
// TDateTimeSpin                                                              //
////////////////////////////////////////////////////////////////////////////////

constructor TDateTimeSpin.Create(AOwner: TComponent);
begin
  inherited;
  FUpDownBtn := TSpinUpDown.Create(Self);
  FUpDownBtn.Parent := Self;
  FUpDownBtn.TabStop := False;
  FUpDownBtn.Visible := True;
  FUpDownBtn.OnUpClick := DoUpClick;
  FUpDownBtn.OnDownClick := DoDownClick;
end;

destructor TDateTimeSpin.Destroy;
begin
  if Assigned(FUpDownBtn) then FreeAndNil(FUpDownBtn);
  inherited Destroy;
end;

procedure TDateTimeSpin.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN;
end;

procedure TDateTimeSpin.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

function TDateTimeSpin.GetAcceleration: Boolean;
begin
  if Assigned(FUpDownBtn) then
    Result := FUpDownBtn.Acceleration
  else
    Result := True;
end;

procedure TDateTimeSpin.SetAcceleration(Value: Boolean);
begin
  if Assigned(FUpDownBtn) then FUpDownBtn.Acceleration := Value;
end;

procedure TDateTimeSpin.SetEnabled(Value: Boolean);
begin
  if Enabled = Value then Exit;
  inherited SetEnabled(Value);
  if Assigned(FUpDownBtn) then FUpDownBtn.Enabled := Value;
end;

procedure TDateTimeSpin.SetEditRect;
var
  Loc: TRect;
begin
  Loc.Bottom := ClientHeight;
  if NewStyleControls and Ctl3D then
    Loc.Right := ClientWidth - FUpDownBtn.Width - 2
  else
    Loc.Right := ClientWidth - FUpDownBtn.Width;
  Loc.Top := 1;
  Loc.Left := 0;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;

procedure TDateTimeSpin.SetBtnRect;
var
  nLft, nTop, nWid, nHei: Integer;
begin
  if not Assigned(FUpDownBtn) then Exit;
  nWid := FUpDownBtn.Width;
  nLft := Width - nWid;
  if NewStyleControls and Ctl3D then
  begin
    Dec(nLft, 3);
    nTop := -1;
  end
  else
  begin
    Dec(nLft);
    nTop := 1;
  end;
  CalcBtnHeight(nTop, nHei);
  if BorderStyle = bsNone then
  begin
    Inc(nLft, 2);
    Inc(nTop, 2);
  end;
  FUpDownBtn.SetBounds(nLft, nTop, nWid, nHei);
end;

procedure TDateTimeSpin.CalcBtnHeight(var BtnTop, BtnHeight: Integer);
begin
  BtnHeight := Height - 2;
end;

procedure TDateTimeSpin.WMSize(var Message: TWMSize);
begin
  inherited;
  SetBtnRect;
  SetEditRect;
end;

procedure TDateTimeSpin.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
  if Key = VK_UP then
    DoUpClick(Self)
  else if Key = VK_DOWN then
    DoDownClick(Self);
end;

function TDateTimeSpin.DoMouseWheelUp(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelUp(Shift, MousePos);
  if Result or ReadOnly then Exit;
  DoIncrement(1);
end;

function TDateTimeSpin.DoMouseWheelDown(Shift: TShiftState; MousePos: TPoint): Boolean;
begin
  Result := inherited DoMouseWheelDown(Shift, MousePos);
  if Result or ReadOnly then Exit;
  DoIncrement(-1);
end;

procedure TDateTimeSpin.DoUpClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  DoIncrement(1);
end;

procedure TDateTimeSpin.DoDownClick(Sender: TObject);
begin
  if ReadOnly then Exit;
  if CanFocus then SetFocus;
  DoIncrement(-1);
end;

procedure TDateTimeSpin.DoIncrement(Direction: Smallint);
var
  sText: String;
  nCnt, nSel, nPos, nTmp: Integer;

  function GetSeparatePos(AText: String): Integer;
  var
    nIdx, nLen: Integer;
  begin
    Result := 0;
    nLen := Length(AText) - 1;
    for nIdx := 1 to nLen do
    begin
      if AText[nIdx] in ['0'..'9'] then Continue;
      Result := nIdx;
      Break;
    end;
  end;
begin
  sText := Text;
  nCnt := 0;
  nSel := SelStart + SelLength;
  nTmp := nSel;
  if Kind = dtkTime then
  begin
    nPos := GetSeparatePos(sText);
    while (nPos <= nSel)and(nPos > 0) do
    begin
      if nPos > 1 then
      begin
        Inc(nCnt);
        if nCnt > 2 then Break;
      end;
      Dec(nSel, nPos);
      sText := Copy(sText, nPos + 1, nSel);
      nPos := GetSeparatePos(sText);
    end;
    case nCnt of
    0:   DateTime := (DateTime * HoursPerDay + Direction) / HoursPerDay;
    1:   DateTime := (DateTime * MinsPerDay + Direction) / MinsPerDay;
    else DateTime := (DateTime * SecsPerDay + Direction) / SecsPerDay;
    end;
  end
  else
  begin
    nPos := GetSeparatePos(sText);
    while (nPos <= nSel)and(nPos > 0) do
    begin
      if nPos > 1 then
      begin
        Inc(nCnt);
        if nCnt > 2 then Break;
      end;
      Dec(nSel, nPos);
      sText := Copy(sText, nPos + 1, nSel);
      nPos := GetSeparatePos(sText);
    end;
    case GetLocaleDateOrder of
    doxMDY:
      case nCnt of
      0:   DateTime := IncMonth(DateTime, Direction);
      2:   DateTime := IncMonth(DateTime, Direction * 12);
      else DateTime := DateTime + Direction;
      end;
    doxDMY:
      case nCnt of
      1:   DateTime := IncMonth(DateTime, Direction);
      2:   DateTime := IncMonth(DateTime, Direction * 12);
      else DateTime := DateTime + Direction;
      end;
    else
      if (nCnt = 0)and(nPos = 0) then nCnt := 2;
      case nCnt of
      0:   DateTime := IncMonth(DateTime, Direction * 12);
      1:   DateTime := IncMonth(DateTime, Direction);
      else DateTime := DateTime + Direction;
      end;
    end;
  end;

  //J[\ʒu
  SelStart := nTmp;
end;

end.
///////////////////////////////////////////////////////// (C)2003-2008 L H

